aboutsummaryrefslogtreecommitdiff
path: root/contrib
diff options
context:
space:
mode:
authordylan.araps@gmail.com <dylan.araps@gmail.com>2020-02-27 20:32:58 +0000
committerdylan.araps@gmail.com <dylan.araps@gmail.com>2020-02-27 20:32:58 +0000
commit3d4174d4c01d2235ae8735f781a2a232d9e47707 (patch)
tree04c89ecd67f5cff3c339057cc37d3da480997996 /contrib
parent0661236f43df63e8d02bb8c42e78817c0298b794 (diff)
downloadcpt-3d4174d4c01d2235ae8735f781a2a232d9e47707.tar.gz
kiss-depends-finder: oops
FossilOrigin-Name: c4da587327d688014b36557c51be7b30817b33bd0878836efda89a41f03c6fb5
Diffstat (limited to 'contrib')
-rwxr-xr-xcontrib/kiss-depends-finder42
1 files changed, 42 insertions, 0 deletions
diff --git a/contrib/kiss-depends-finder b/contrib/kiss-depends-finder
new file mode 100755
index 0000000..32b2b17
--- /dev/null
+++ b/contrib/kiss-depends-finder
@@ -0,0 +1,42 @@
+#!/bin/sh -e
+#
+# Find missing dependencies by parsing 'ldd'.
+
+kiss l "${1:-null}" >/dev/null
+
+db_dir=$KISS_ROOT/var/db/kiss/installed
+grep=$(command -v ggrep) || grep='grep'
+
+printf '=> Detected dependencies:\n'
+
+while read -r file || [ "$file" ]; do
+ [ -d "$KISS_ROOT/$file" ] && continue
+
+ ldd "$KISS_ROOT/$file" 2>/dev/null | while read -r dep; do
+ # Skip lines containing 'ldd'.
+ [ "${dep##*ldd*}" ] || continue
+
+ # Extract the file path from 'ldd' output.
+ dep=${dep#* => }
+ dep=${dep% *}
+
+ # Traverse symlinks to get the true path to the file.
+ pkg=$(readlink -f "$KISS_ROOT/${dep##$KISS_ROOT}")
+
+ # Figure out which package owns the file.
+ pkg=$("$grep" -lFx "${pkg##$KISS_ROOT}" "$db_dir/"*/manifest)
+ pkg=${pkg%/*}
+ pkg=${pkg##*/}
+
+ # Skip listing these packages as dependencies.
+ case $pkg in
+ musl|gcc|$1) ;;
+ *) printf '%s\n' "$pkg" ;;
+ esac
+ done
+done < "$db_dir/$1/manifest" | sort -u
+
+printf '\n=> Package dependencies:\n'
+
+[ -f "$db_dir/$1/depends" ] &&
+ cat "$db_dir/$1/depends"